> For the complete documentation index, see [llms.txt](https://docs.rierino.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rierino.com/devops/api-event-and-process-flows/configuring-saga-steps/event-step/core-actions/apply-rules.md).

# Apply Rules

These actions provide ability to evaluate a list of rules and returns results based on matches.

## Apply Rules Actions

### Process / ProcessSimpleRules

Evaluates list of rules for a domain and returns the result of matching rule. Event metadata fields applicable for this action are as follows:

{% tabs %}
{% tab title="Table" %}

| Field          | Definition                                                                                           | Example       | Default |
| -------------- | ---------------------------------------------------------------------------------------------------- | ------------- | ------- |
| Domain         | Set of rules to apply                                                                                | risk\_scoring | -       |
| Input Element  | Json path for the input in event payload for query variables                                         | parameters    | -       |
| Output Element | Json path for the output in response event payload where "result" or "results" element will be added | $.decision    | -       |
| {% endtab %}   |                                                                                                      |               |         |

{% tab title="JSON Schema" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "domain": {
          "type": "string",
          "description": "Set of rules to apply",
          "example": "risk_scoring"
        },
        "inputElement": {
          "type": "string",
          "description": "Json path for the input in event payload for query variables",
          "example": "parameters"
        },
        "outputElement": {
          "type": "string",
          "description": "Json path for the output in response event payload where \"result\" or \"results\" element will be added",
          "example": "$.decision"
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}

With event metadata parameters as:

{% tabs %}
{% tab title="Table" %}

| Parameter     | Definition                                                                                          | Example                   | Default |
| ------------- | --------------------------------------------------------------------------------------------------- | ------------------------- | ------- |
| Input Pattern | JMESPath pattern to apply on data input                                                             | {id:id, group:data.group} | -       |
| Structure     | Whether the "result" of highest salience rule or "results" list of all matching rules should return | list                      | single  |
| {% endtab %}  |                                                                                                     |                           |         |

{% tab title="JSON Schema" %}

```json
{
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "type": "object",
  "properties": {
    "eventMeta": {
      "type": "object",
      "properties": {
        "parameters": {
          "type": "object",
          "properties": {
            "inputPattern": {
              "type": "string",
              "description": "JMESPath pattern to apply on data input",
              "example": "{id:id, group:data.group}"
            },
            "structure": {
              "type": "string",
              "description": "Whether the \"result\" of highest salience rule or \"results\" list of all matching rules should return",
              "enum": ["single", "list"],
              "default": "single",
              "example": "list"
            }
          }
        }
      }
    }
  }
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.rierino.com/devops/api-event-and-process-flows/configuring-saga-steps/event-step/core-actions/apply-rules.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
